#!/usr/bin/perl

# Logistic map : g(x) = ax(1-x)
# Dumps data for bifurcation diagram as a changes from 1 to 4

$usage = <<'EOF' ;
usage: logistic.pl [-h] [-r] [<start_a> <end_a>]
	g(x) = ax(1-x)
	-h : help
	-r : raw data (not bifurcation diagram)
EOF

# Print help message
require "getopts.pl";
&Getopts('hr');

if ($opt_h) {
	print $usage;
	exit(0);
}

# Set default interval for the parameter value "a"
if ($#ARGV==1) {
	$start_a = $ARGV[0];
	$end_a = $ARGV[1];
} else {
	$start_a = 1.0;
	$end_a = 4.0;
}

# Divide the interval into 5000 sections.
$interval = ($end_a - $start_a)/3000.0;

# For each section, calculate 200 iterations and plot only the 
# last 10 iterations
for ($a = $start_a; $a<=$end_a; $a += $interval) {

	$x = rand(1.0);
	if ($opt_r) {
		for ($i=0; $i < 1000; ++$i) {
			$x = $a * $x * (1 - $x);
			print "$x\n";
		}
		last;
 	} else {	
		for ($i=0; $i < 200; ++$i) {
			$x = $a * $x * (1 - $x);
			if ($i>190) {
				print "$a $x\n";
			}
		}
	}

}
		
		
		
