//----------------------------------------------------------------------------
// 
//	file: net_window.h
// 
//	function:  
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Fri Aug  7 03:38:17 CDT 1998
// 
//	$Revision: 1.1 $ $Date: 1998/08/11 16:57:14 $
//	$Log: net_window.h,v $
//	Revision 1.1  1998/08/11 16:57:14  yschoe
//	display mesh-like network coordinates
//
//
//----------------------------------------------------------------------------
#ifndef __NET_WINDOW_H
#define __NET_WINDOW_H

#include <window.h>
#include <iostream.h>
#include "util.h"
#include "real.h"
#include "plot_window.h"
#include "coord.h"

enum NET_WIN_BOOL {NET_WIN_TRUE, NET_WIN_FALSE};

//----------------------------------------------------------------------------
//	CLASS: net_window() 
//	  - displaying graph of datapoints (positive REAL values)
//----------------------------------------------------------------------------
class net_window : public plot_window {

protected:

  int	cols;
  int	rows;
  NET_WIN_BOOL  ideal_alloced;

  coord **ideal;	// ideal coordinate matrix
  coord **cog_matrix;	// matrix to be displayed

  virtual void DrawGrid(coord **grid);
  virtual void init(int cols, int rows,
		REAL min_x, REAL max_x, REAL min_y, REAL max_y,
		coord **cog_matrix, coord **ideal);

public:

  // use REAL *oned; for data point storage
  // see matrix_window public 

  	net_window(window &parent, int w, int h, int x, int y, int bw,
		int color_range, int color_mode, 
		int cols, int rows, // matrix size
		REAL min_x, REAL max_x, REAL min_y, REAL max_y, // grid size
		coord **cog_matrix);
  	net_window(window &parent, int w, int h, int x, int y, int bw,
		int color_range, int color_mode, 
		int cols, int rows, // matrix size
		REAL min_x, REAL max_x, REAL min_y, REAL max_y, // grid size
		coord **cog_matrix, coord **ideal);
  	~net_window();

  virtual void 	draw_interior();	// actual display routine

};
#endif
