#!/usr/bin/perl

$usage = <<EOF;
usage: aspect.pl [-x <target-x>] [-y <target-y>] <original-x> <original-y> 

	scale original dimension so that either target-x or target-y matches,
	while maintaining aspect ration <original-x>:<original-y>

EOF

if ( $ARGV[0] eq "-x" ) {

	shift;
	$tx = $ARGV[0];
	shift;
}

if ( $ARGV[0] eq "-y" ) {

	shift;
	$ty = $ARGV[0];
	shift;
}

if ($#ARGV != 1) {
	print $usage;
	exit;
}

$x = $ARGV[0];
$y = $ARGV[1];

if ($tx>0) { # align x
	$nx = $tx;
	$ny = $y*$tx/$x;
	print "$x x $y --> $nx x $ny (";
}

if ($ty>0) { # align y
	$ny = $ty;
	$nx = $x*$ty/$y;
	print "$x x $y --> $nx x $ny";
}

print "\n";
