#!/usr/bin/perl

$usage = <<'EOF';
usage: contint.pl <size> <zoom> <elem-density> <radius> <rand>

	size: n x n raw size (e.g., 100)
	zoom: zoom factor (e.g., 4)
	elem-density: 0.0 to 1.0 -- how densly packed (e.g., 0.01)
	radius: contour element radius (e.g., 1)
	rand: randomness in positioning from grid (e.g., 0.5)

EOF

if ($#ARGV != 4) {
	print $usage;
	exit;
}

$size = $ARGV[0];
$zoom = $ARGV[1];
$density = $ARGV[2];
$radius = $ARGV[3];
$rand = $ARGV[4];

$thick = 2;

# derived values
$num_elem = $size * $size * $density;
$per_row = sqrt($num_elem);
$cell_size = int($size/$per_row);

$cmd_str = "annoteppm.tcl $size $zoom noppm ";

$xyhash{"0:0"} = 1;

print STDERR "cell_size = $cell_size \n";

$rand = $rand * $cell_size;

if (0) {
for ($i = 0; $i<$num_elem; ++$i) {

	$x = int(rand()*$size);
	$y = int(rand()*$size);

	$hx = int($x/$cell_size+0.5);
	$hy = int($y/$cell_size+0.5);
	while (&check_overlap($hx,$hy,\%xyhash,\$num_fail) == 1 
		|| ($x-$size/2.0)**2+($y-$size/2.0)**2 > $size**2.0/4.0) {

		$x = int(rand()*$size);
		$y = int(rand()*$size);

		$hx = int($x/$cell_size+0.5);
		$hy = int($y/$cell_size+0.5);
		
	}

	$hx = int($x/$cell_size);
	$hy = int($y/$cell_size);
	$xyhash{"$hx:$hy"}=1;

	$theta = int(rand()*180);

	$cmd_str .= "line,$x,$y,$radius,$theta,$thick,black:circ,$x,$y,1,red:";

}
}

for ($i=0; $i<$per_row; ++$i) {
  for ($j=0; $j<$per_row; ++$j) {
    if (($i-$per_row/2.0)**2+($j-$per_row/2.0)**2 < $per_row**2.0/4.0) {
	$x = int($i * $cell_size + (0.5-rand())*$rand);
	$y = int($j * $cell_size + (0.5-rand())*$rand);
	$theta = int(rand()*180);
	#$cmd_str .= "line,$x,$y,$radius,$theta,$thick,black:circ,$x,$y,1,red:";
	$cmd_str .= "line,$x,$y,$radius,$theta,$thick,black:";
    }
  }
}

chop $cmd_str;

`$cmd_str`;

print $cmd_str."\n";

#----------------------------------------------------------------------------
sub check_overlap {

  my ($x,$y,$hashref,$num_fail_ref) = @_;
  
  if (exists($$hashref{"$x:$y"})) {
	$$num_fail_ref++;
	return 1;
  } else {
	return 0;
  }
} 

  
