# function I = digittomat(D,x)
#	I : resulting n x m matrix where 
#		n is the number of units and m the input dimension
#		(m = x * x)
#	D : x x x input matrix pasted from top to bottom
#
#	* reshape() follows column-major, so it needs to be transposed
#
# $Id: somwtodat.m,v 1.2 2003/11/06 07:55:33 yschoe Exp yschoe $
#
function I = digittomat(D,x)

  num_inp = rows(D)/x;

  I = zeros(num_inp,x*x);
  for i=0:(num_inp-1)
	M = D(i*x+1:i*x+x,:);
	v = reshape(flipud(M)',1,x*x);
	I(i+1,:) = abs(1.-v);
  endfor

endfunction

