function [evects,evals] = truepca(dataset)
% [evects,evals] = truepca(dataset)
%
% USUAL WAY TO DO PCA -- find sample covariance and diagonalize
%
% input: dataset 
% note, in dataset, each COLUMN is a datapoint
% the data mean will be subtracted and discarded
% 
% output: evects holds the eigenvectors, one per column
%         evals holds the corresponding eigenvalues
%

[d,N]  = size(dataset);

mm = mean(dataset')';
dataset = dataset - mm*ones(1,N);

# original: cc = cov(dataset',1)
# yschoe: in octave, cov(X,1) does not exist.
# 	The difference between cov(X) and cov(X,1) is that
#	cov(X) is a result of normalizing with N-1 to produce an unbiased
#	estimate, while cov(X,1) results from normalizing with N.
#	To correct this, simply do
# 		cov(X,1) = cov(X)*(n-1)/n, where n==number of observations.
cc = cov(dataset')*(N-1)/N;
[cvv,cdd] = eig(cc);
[zz,ii] = sort(diag(cdd));
ii = flipud(ii);
evects = cvv(:,ii);
cdd = diag(cdd);
evals = cdd(ii);


