# function [n,x] = exphist(vec,binsize)
#	get a histogram where the binsize increases exponentially

function [n,x] = exphist(v,binsize)

  max_x = log10(max(v));
  min_x = log10(min(v));

  log_step = floor((max_x-min_x)/binsize);

  n = zeros(1,binsize);

  s = max(size(v));

  for i=1:s
	x(i) = 10**log_step;
  endfor

  for i=1:s
	bindex = rem(log(v(i)*10000),log_step*10000);
	n(bindex) ++;
  endfor

endfunction
	
