#!/usr/bin/perl
#!/usr/bin/perl

$usage = <<'EOF';
usage: genfig2.pl <input-spec> <muaplotfile> <bottom-scale> <#-nrn>

	* Note that the max ppm file or image file size (width) is 1000,
	  and it is assumed that smaller images have an integer
	  multiple which equals 1000.

	-f <fontsize> 	: optional

	input-spec: 
		'i' for input, 'b' for blank, connected by ':'

		i:i:i:i:i  : for 5 consecutive inputs
		i:b:i:b:i:b : for 3 inputs, alternating

	muaplotfile:
		
		a png, pdf, or jpg file.

	bottom-scale:

		begin:end:step

		1:500:100	: from 1 to 500, with ticks at every 100

	num-nrn:

		number of neurons

Output: a single pdf file with everything included (uses Tcl).

EOF

if ($ARGV[0] eq "-f") {
	$fsize = 1;
	shift;
} else {
	$fsize = 0;
}

print STDERR "argv = $#ARGV\n";
if ($#ARGV != 3) {
	print $usage;
	exit;
}

$count = 0;
$input_spec = $ARGV[$count++];
$muafile = $ARGV[$count++];
$scale = $ARGV[$count++];
$num_neurons = $ARGV[$count];

#----------------------------------------
# Call genmuaplot.tcl
#----------------------------------------
# set filename    [lindex $argv 0]
# set width       [lindex $argv 1]
# set height      [lindex $argv 2]
# set input_spec  [lindex $argv 3]
# set input_tick_spec  [lindex $argv 4]
# set conn_spec  [lindex $argv 5]
# set conn_tick_spec  [lindex $argv 6]
# set scale_spec  [lindex $argv 7]

$fname = '/tmp/genmuaplot.temp.ppm';
`convert $muafile $fname`;

$sizestr = `identify $fname`;
chop $sizestr;
$sizestr =~ /[\s]+([0-9]+x[0-9]+)[\s]+/;
($width,$height) = split(/x/,$1);

@inps = split(/:/,$input_spec);
$num_inp = $#inps+1;
$input_tick_spec =  "";
$gran=int($num_neurons/($num_inp*1.0));
for ($i=0; $i<$num_inp; ++$i) {
	if ($i==0) {
		$input_tick_spec .= "1:";
	} elsif ($i==$num_inp) {
		$input_tick_spec .= $num_neurons;
	} else {
		$input_tick_spec .= ($gran*($i+1)).":";
	}
}

$scale_spec = $scale;

$execstr = "genmuafig2.tcl $fname $width $height $input_spec $input_tick_spec $scale_spec";

print "\n";
print "\n";
print "\n";
print $execstr."\n";

`$execstr`;

$basename = `basename $muafile .ppm`;
chop $basename;

`mv genfig.ps $basename.ps`;
`epstopdf $basename.ps`;
`acroread $basename.pdf`;

