# usage: [A,C] = mcoherence(X), where each column is a time series
#	: returns the coherence (degree of synchronization) among
# 	  all sequences
# 	: defined by Hansel et al.
#	: A : autocorrel
#	: C : crosscorrel
function C = mcoherence(X)

	cols = columns(X);

	C = zeros(1,cols*(cols-1)/2);
	k = 1;
	for i=1:cols
		for j=(i+1):cols
			C(k) = coherence([X(:,i),X(:,j)]);
			plot(C);
			k++;
		endfor
	endfor
endfunction


