# function [R,C,N] = motifs()
#
#	generate 3-motifs:
#		R : raw (disconnected graphs allowed)
#		C : connected, but may be isomorphic
#		N : connected, nonisomorphic
function [R,C,N] = motifs()

  # generate R

  R = [];
  conn_v = [];
  conn_iso_v = [];
  connected = 0;
  disconnected = 0;

  for i=0:1 for j=0:1 for k=0:1 for l=0:1 for m=0:1 for n=0:1

	vv  = [0, i, j, k, 0, l, m, n, 0];
	v  = reshape([0, i, j, k, 0, l, m, n, 0],3,3);

	R  = [R; vv];
	#   edges >= 3 or 2 edges that aren't between the the same nodes
	if (sum(vec(v))>=3 || (sum(vec(v))==2 && sum(vec(v!=v'))!=0))
		# printf("connected\n");
		[r,c]=size(conn_v);
		redundant=0;
		if (r>=1) 
			for x=1:r
				if (isomorph3(reshape(conn_v(x,:),3,3),v)==1)
					redundant=1;
					break;	
				endif
			endfor
		endif
		if (redundant==0)
			conn_v = [conn_v; vv];
			connected++;
		endif

		conn_iso_v = [conn_iso_v; vv];
	else
		# printf("disconnected\n");
		# disconnected++;
	endif

  endfor endfor endfor endfor endfor endfor
 
  C = conn_iso_v;
  N = conn_v;

endfunction
  

