# function [R,C,N] = motifs_c()
#
#	generate 3-motifs (with/without loops):
#		R : raw (disconnected graphs allowed)
#		C : connected, but may be isomorphic
#		N : connected, nonisomorphic
function [R,C,N] = motifs_c()

  # generate R

  R = [];
  conn_v = [];
  conn_iso_v = [];
  connected = 0;
  disconnected = 0;

  for i=0:1 for j=0:1 for k=0:1 for l=0:1 for m=0:1 for n=0:1 for o=0:1 for p=0:1 for q=0:1

	vv  = [i, j, k, l, m, n, o, p, q];
	v  = reshape([i, j, k, l, m, n, o, p, q],3,3);

	R  = [R; vv];
	#   edges >= 3 or 2 edges that aren't between the the same nodes
	# if (((sum(vec(v))-trace(v))>=3) || ((sum(vec(v))-trace(v))==2 && sum(vec(v!=v'))!=0))

	# if (sum(vec(sign(v+v')))-trace(sign(v+v')) ==6)
	# if (sum(vec(sign(v+v')))-trace(sign(v+v')) > 2)
	# gives 86 if (sum(vv)!=1 && !(sum(vv)==2 && sum(sign(vec(v+v')))==2))
	# gives 76 if (sum(vv)-trace(v)!=1 && !(sum(vv)-trace(v)==2 && sum(sign(vec(v+v')))-trace(v)*2==2))

	if (sum(vv)-trace(v)<=1)
		printf("single edge ----\n");
		v,
		break;
	endif

	#if (sum(vv)-trace(v)==2 && sum(sign(vec(v+v'))-trace(v)==2)
	if (sum(vv)-trace(v)==2 && is_symmetric(v))

		printf("disconnected ----\n");
		v,
		break;
	endif
		
		# printf("connected\n");
		[r,c]=size(conn_v);
		redundant=0;
		if (r>=1) 
			for x=1:r
				if (isomorph3(reshape(conn_v(x,:),3,3),v)==1)
					printf("isomorphic ----\n");
					reshape(conn_v(x,:),3,3),
					printf("reject ----\n");
					v,
					redundant=1;
					break;	
				endif
			endfor
		endif
		if (redundant==0)
			conn_v = [conn_v; vv];
			connected++;
			printf("%d\n",connected);
		endif

		conn_iso_v = [conn_iso_v; vv];

  endfor endfor endfor endfor endfor endfor endfor endfor endfor
 
  C = conn_iso_v;
  N = conn_v;

endfunction
  

