#!/usr/bin/wish


global xval nval width height max n

# number of bins
set n 36

set width 30
set height 180

#----------------------------------------------------------------------------
# 	hsvtorgb
#----------------------------------------------------------------------------
proc HSVToRGB { colorBoxHue colorBoxSat colorBoxValue} {
# xf ignore me 6
# The HSV <-> RGB converting routines are from the
# tcolor demo that is part of the demo site of Tk.
# From: 
# http://www.mit.edu/afs/sipb/project/tcl/linuxbin/xfpixmap
#!/afs/sipb/project/tcl/wish -f
# Program: xfpixmap
# Tcl version: 6.6 (Tcl/Tk/XF)
# Tk version: 3.1
# XF version: $__lastrelease$

  set colorBoxV [format %.0f [expr 255.0*$colorBoxValue]]
  if {$colorBoxSat == 0} {
    return [format "#%02x%02x%02x" $colorBoxV $colorBoxV $colorBoxV]
  } else {
    set colorBoxHue [expr $colorBoxHue*6.0]
    if {$colorBoxHue >= 6.0} {
      set colorBoxHue 0.0
    }
    scan $colorBoxHue. %d i
    set colorBoxF [expr $colorBoxHue-$i]
    set colorBoxP [format %.0f [expr {255.0*$colorBoxValue*(1 - $colorBoxSat)}]]
    set colorBoxQ [format %.0f [expr {255.0*$colorBoxValue*(1 - ($colorBoxSat*$colorBoxF))}]]
    set colorBoxT [format %.0f [expr {255.0*$colorBoxValue*(1 - ($colorBoxSat*(1 - $colorBoxF)))}]]
    case $i       0 {return [format "#%02x%02x%02x" $colorBoxV $colorBoxT $colorBoxP]} \
      1 {return [format "#%02x%02x%02x" $colorBoxQ $colorBoxV $colorBoxP]} \
      2 {return [format "#%02x%02x%02x" $colorBoxP $colorBoxV $colorBoxT]} \
      3 {return [format "#%02x%02x%02x" $colorBoxP $colorBoxQ $colorBoxV]} \
      4 {return [format "#%02x%02x%02x" $colorBoxT $colorBoxP $colorBoxV]} \
      5 {return [format "#%02x%02x%02x" $colorBoxV $colorBoxP $colorBoxQ]}
    puts stderr "i value $i is out of range"
  }
}

#----------------------------------------------------------------------------
# 	plotnet: plot c.o.g.s net 
#----------------------------------------------------------------------------
proc plotnet { } {

	global width height nval xval n

	set w [expr $width * 1.1]
	set h [expr $height * 1.05]
	for {set i 0} {$i<$n} {incr i} {
		set xbegin 0
		set xend   [expr int($nval($i)*$w/1.65)]
		set ybegin [expr int($i * ($h/($n*1.0)))]
		set yend   [expr int(($i+1) * ($h/($n*1.0)))-1]
		if {$i==[expr $n-1]} {
			set yend [expr $height]
		}
  		.misc.net create rectangle\
			$xbegin $ybegin $xend $yend \
			-fill [HSVToRGB [expr abs(1-$i/($n*1.0))] 1.0 1.0]  \
			-outline [HSVToRGB [expr abs(1-$i/($n*1.0))] 1.0 1.0] 
	}

	.misc.net create rectangle 0 0 [expr $width] [expr $height] \
		-outline black
}


#----------------------------------------------------------------------------
#
# 	MAIN:
#
#----------------------------------------------------------------------------

#----------------------------------------
# 0. Load OR histogram
#----------------------------------------
set fp [open [lindex $argv 0]]
set max -99999
for {set i 0} {$i<$n} {incr i} {

  set line [string trim [gets $fp] " "]
  set cols [split $line " "]
  set xval($i) [lindex $cols 0]
  set nval($i) [lindex $cols 1]
  if { $nval($i) > $max } {
	set max $nval($i)
  }
}
close $fp

for {set i 0} {$i<$n} {incr i} {
	set nval($i) [expr $nval($i)/($max*1.0)]
}

#----------------------------------------
# 1. Create display window
#----------------------------------------
frame .misc -relief ridge; pack .misc -padx 10 -pady 10

canvas .misc.net -relief sunken -borderwidth 1 -background white \
	-height $height -width $width
pack .misc.net -side left -padx 10 -pady 5 ; 

button .psdump -command { \
        .misc.net postscript -file [lindex $argv 0].ps ; \
        } -text "PS Dump"
pack .psdump -side left

button .quit -command { exit } -text "Quit"
pack .quit -side top -padx 10 -pady 10

plotnet
