# usage: Y = pad(X,n) : embed an m x m matrix X 
# in a n x n matrix of zeros (m < n)
function Y = pad(X,n) 
	# no error condition check

	Y = zeros(n,n);
	c = columns(X);
	r = rows(X);
	if (c>n || r>n) 
		printf "src matrix is larger than target matrix"
	else
		c_offset = floor(( n - c )/2);
		r_offset = floor(( n - r )/2);
		
		for i=c_offset:(c_offset+c-1)
			for j=r_offset:(r_offset+r-1)
				Y(j,i) = X(j-r_offset+1,i-c_offset+1);
			endfor
		endfor
	endif

endfunction

