#!/usr/bin/perl

$usage = <<EOF;
usage: mkwgtorstat.pl [-f|-p] [-m] <n> <wgt_or.stat-filename>
	-f  : theta only
	-p  : prob only
	-m  : max polar instead of probpolar
	<n> : size of map <n> x <n>

EOF


require "getopts.pl";
&Getopts('ptm');
	
if ($#ARGV != 1) {
	print $usage;
	exit;
}

$size = $ARGV[0];
$fname = $ARGV[1];
$option = ($opt_m)?"-maxpolar":"-probpolar";

#----------------------------------------
#	1. make the max theta plot
#----------------------------------------

if (!$opt_p) {
print "\n\n\n** Running procwgtstat-balanced-hue.pl **\n\n\n\n";
system("procwgtstat-balanced-hue.pl -huepolar $size 0.001 $fname > $fname.huethetapolar");

print "\n\n\n** Done **\n\n\n\n";

system("polarlines3.tcl $fname.huethetapolar");
}

#----------------------------------------
#	2. make the cumulative probability plot
#----------------------------------------

if (!$opt_f) {
print "\n\n\n** Running procwgtstat-balanced-hue.pl **\n\n\n\n";
system("procwgtstat-balanced-hue.pl $option $size 0.0 $fname > $fname.huethetaprobpolar");

print "\n\n\n** Running polarmat.pl **\n\n\n\n";
system("polarmat.pl -S -p -a 10 $fname.huethetaprobpolar > $fname.huethetaprobpolar.polarmat");

system("procppmmat $fname.huethetaprobpolar.polarmat");

print "\n\n\n** Done **\n\n\n\n";
}


